package net.weasel.BlockRez;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Scanner;
import java.util.logging.Logger;

import org.bukkit.Location;
import org.bukkit.Server;
import org.bukkit.World;
import org.bukkit.block.Block;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.plugin.PluginManager;
import org.bukkit.plugin.java.JavaPlugin;

public class BlockRezMain extends JavaPlugin
{
    protected static final String version = "1.0";
	
	public static HashMap<Block,Integer> rezBlocks = new HashMap<Block,Integer>();
	
	public static String pluginName = "";
	public static String pluginVersion = "";
	public static BlockRezMain plugin;
	public static Server server;
	public static World world;	
	public static BlockRezListener bListener = null;
	public static PluginManager pm = null;
    public static boolean debugging = false;

    public final BlockRezListener blockListener = new BlockRezListener( this );

    protected static Logger log = Logger.getLogger("Minecraft");

    public void onEnable()
    {
    	plugin = this;
    	server = plugin.getServer();
    	pm = server.getPluginManager();

        pm.registerEvents( blockListener, this );
        logOutput( pluginName + " v" + pluginVersion + " enabled." );
    }
    
    public void onDisable()
    {
    	logOutput( pluginName + " v" + pluginVersion + " disabled." );
    }

    public boolean onCommand(CommandSender sender, Command cmd, String commandLabel, String[] args) {

        if( cmd.getName().equalsIgnoreCase( "setblock" ) ) 
        {
        	BlockRezCommands.SetBlock( (Player)sender );
        	return true;
        }
        
        if( cmd.getName().equalsIgnoreCase( "unsetblock" ) ) 
        {
        	BlockRezCommands.UnsetBlock( (Player)sender );
        	return true;
        }
        
        if( cmd.getName().equalsIgnoreCase( "checkblock" ) ) 
        {
        	BlockRezCommands.CheckBlock( (Player)sender );
        	return true;
        }
        
		return false;
    }
    
	public static void saveBlockList( HashMap<Block,Integer> blockList, String filename ) throws IOException
    {
    	FileOutputStream buf = new FileOutputStream( new File( filename ), true );
    	ObjectOutputStream output = new ObjectOutputStream( buf );
		   
		output.writeObject( blockList );
		output.close();
    }
    
    public static HashMap<Block,Integer> readBlockList( String filename ) throws IOException, ClassNotFoundException
    {
    	FileInputStream buf = new FileInputStream(new File ("StringArray_demo.txt"));
    	ObjectInputStream input = new ObjectInputStream( buf );
    	
    	@SuppressWarnings("unchecked")
		HashMap<Block,Integer> output = (HashMap<Block, Integer>)input.readObject();
		
		return output;    
	}
    
    public static void logOutput( String message )
    {
    	log.info("[" + pluginName + "] " + message );
    }
}
